require('sketchup')
if Sketchup.version.to_i <= 8
  require('dynamiccomponents.rb')
else
  require('su_dynamiccomponents.rb')
end

if defined?($dc_observers)
  class DCFunctionsV1
    # =t2swapcomponent("/Users/hai/SketchUp/Curic/Lib/Doors", purge)
    unless DCFunctionsV1.method_defined?(:t2swapcomponent)
      def t2swapcomponent(param_array)
        return CURIC::DCUI::DCFunctions.t2swapcomponent(@source_entity, param_array)
      end

      protected :t2swapcomponent
    end

    # =t2display(attribute)
    unless DCFunctionsV1.method_defined?(:t2display)
      def t2display(param_array)
        # p 't2display'
        unless param_array.length == 2
          return '#ERROR: need an array with 2 args.'
        end

        control_attr, list_attr = param_array

        dc = $dc_observers.get_latest_class
        attrs = dc.get_attribute_list(@source_entity, true)

        if attrs.include?(control_attr.downcase) && attrs.include?(list_attr.downcase)
          value = "#{control_attr.downcase}|#{list_attr.downcase}"
        else
          value = 'false'
        end

        value
      end

      protected :t2display
    end
  end
end
