// Custom Attribute
Vue.component("divider-attribute", {
  model: {
    prop: "attribute",
    event: "change",
  },
  props: {
    attribute: {
      type: Object,
    },
    parent: {
      type: Object,
    }, 
    group: {
      type: Object,
    },
    layout: {
      type: Object,
    },
    disabled: {
      default: false,
      type: Boolean,
    },
    onEdit: {
      default: false,
      type: Boolean,
    },
    display_action: {
      default: true,
      type: Boolean,
    },
    image_input_height: {
      default: 'auto',
      type: String,
    },
    zindex: {
      default: 100,
      type: Number,
    },
  },
  data: function () {
    return {
    }
  },
  template: `
  <span>
    <div :style="{margin: attribute.formlabel != '' ? '15px 0' : '5px 0'}">
      <el-divider class="section-attribute"
        :direction="attribute.direction"
        :content-position="attribute.label_position">
        <span v-if="attribute.formlabel != ''" 
          @dblclick="$root.editAttributeLabel(attribute)"
          class="subtitle"
          v-html="attribute.formlabel">
        </span>
      </el-divider>
    </div>
  </span>
  `,
  methods: {
    insertField(e){
    },
    dividerClass(){
      a = this.attribute.name != '' ? 'section-attribute' : ''
      return this.attribute.name != '' ? 'section-attribute' : '';
    }
  },
  computed: {
    dividerStyle(){
      if (this.attribute.name != ''){
        return {margin: '10px 0'}
      } else {
        return {margin: '5px 0'}
      }
    }
  },
  mounted: function (){
  }
});
