// Edit Attribute
Vue.component("edit-attribute", {
  model: {
    prop: "attribute",
  },
  props: {
    attribute: {
      type: Object,
    },
    parent: {
      type: Object,
    },
    onEdit: {
      default: false,
      type: Boolean,
    }, 
    inline: {
      default: false,
      type: Boolean,
    },
  },
  template: `
    <span>
      <span class="action-icon edit-attribute" v-if="onEdit"
        @click="$root.editAttribute(attribute)">
          <i class="fa fa-pencil" aria-hidden="true"></i>
      </span>
      <template v-if="$root.isCustomAttribute(attribute) && onEdit">
        <div class="action-icon edit-attribute" :style="{display: (inline ? 'inline-block' : 'block')}"
          @click="removeAttr()">
          <i class="fa fa-trash"></i>
        </div>
      </template>
    </span>
  `,
  methods:{
    removeAttr() {
      this.$confirm('Delete?', 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(() => {
        this.$root.removeCustomAttribute(this.attribute, this.parent)
        this.$message({
          type: 'success',
          message: 'Delete completed'
        });
      }).catch(() => {
        this.$message({
          type: 'info',
          message: 'Delete canceled'
        });          
      });
    }
  },
  created() {
    if (this.attribute.access == 'Divider'){
      this.inline = true
    }
  }
});
