// Icon
Vue.component("attribute-icon", {
  model: {
    prop: "attribute",
  },
  props: {
    attribute: {
      type: Object,
    },
    render: {
      default: true,
      type: Boolean
    }
  },
  template: `
    <div v-if="render && attribute.image && attribute.access != 'Image'" class="input-icon">
      <template v-if="attribute.image.extname == '.svg'">
        <span v-html="attribute.image.src" style="display: flex;"></span>
      </template>
      <template v-else>
        <el-image v-if="attribute.on_edit"
          :src="attribute.image ? attribute.image.base64 : ''"
          atl="icon" fit="scale-down">
          <div slot="error"><i class="fa fa-image fa-2x"></i></div>
        </el-image>
        <img v-else :src="attribute.image ? attribute.image.base64 : ''" alt="icon">
      </template>
    </div>
  `,
  mounted: function (){
    self = this;
    this.attribute.refreshIcon = function() {
      self.render = false;
      self.$nextTick((_)=>{
        self.render = true;
      })
    }
  }
});