// Label
Vue.component("attribute-label", {
  model: {
    prop: "attribute",
  },
  props: {
    attribute: {
      type: Object,
    },
    onEdit: {
      default: false,
      type: Boolean,
    }, 
    path: {
      default: '',
      type: Boolean,
    },
  },
  template: `
    <span @dblclick="$root.editAttributeLabel(attribute)"
      :title="onEdit ? attribute.name : null"
      style="user-select: none;">
      <span v-if="!attribute.hide_label"
        class="attribute-label-html" v-html="labelText" :style="labelStyle"></span>

      <span v-if="attribute.symbol && !attribute.hide_label"> - </span>

      <span v-if="attribute.symbol"><b style="color: red;">{{attribute.symbol}}</b></span>
    </span>
  `,
  computed :{
    labelText: {
      get(){
        
        let objectPath = attributeTreePath(this.path);
        let parent = objectPath.reverse().find(o => { 
          return o && (o.access == 'Fieldset' ||
          o.access == 'Block' ||
          o.access == 'Column' ||
          o.access == 'Group') && 
          o.hide_by_label
        })
        
        // console.log('labelText.get', parent, 'path', this.path)

        if (parent){
          var prefix;
          if (parent.access == 'Fieldset' && parent.legends && parent.legends[0]){
            let legend = parent.legends[0]
            if(this.attribute != legend){
              prefix = legend.formlabel
            }
          } else {
            prefix = parent.name;
          }

          return this.attribute.formlabel.replace(prefix, '');
        }
        
        return this.attribute.formlabel;
      }
    },
    labelStyle(){
      let label_style = this.attribute.label_style;
      if (!label_style) return {};

      return {
        'font-weight': label_style.includes('bold') ? 'bold' : 'normal',
        'font-style': label_style.includes('italic') ? 'italic' : 'normal',
        'text-decoration': label_style.includes('underline') ? 'underline' : 'unset',
        color: this.attribute.label_text_color
      }
    }
  },
});