const PLUGIN_ID = 'Curic Dynamic Component UI+';

function newVue() {
  return new Vue({
    el: "#app",
    data: function () {
      return {
        // Test
        width: 0,
        height: 0,
        x: 0,
        y: 0,

        // 
        hoverCollectionTitle: false,

        data: null,
        t_radio: 1,
        rb_value: null,
        xs: 383,
        sm: 384,
        md: 496,
        lg: 600,
        xl: 960,
        
        sub_d :[],
        dialog_settings:{},

        mathOperators: [
          '==',
          '!=',
          '>',
          '<',
          '>=',
          '<=',
          '==',
        ],
        optionImageSizes: {
          tiny: {
            padding: "2px 5px !important",
            imageSize: {
              height: "24px",
              "max-width": "32px",
            },
          },
          mini: {
            padding: "2px 5px !important",
            imageSize: {
              height: "32px",
              "max-width": "48px",
            },
          },
          small: {
            padding: "5px 7px !important",
            imageSize: {
              height: "48px",
              "max-width": "64px",
            },
          },
          medium: {
            padding: "5px 10px !important",
            imageSize: {
              height: "64px",
              "max-width": "72px",
            },
          },
          large: {
            padding: "7px 15px !important",
            imageSize: {
              height: "72px",
              "max-width": "96px",
            },
          },
        },

        vv: "tiny",
        dynamic_attributes: [],
        attr_groups: [],
        collection: null,
        show_product_info: true,
        show_test_api: true,
        test_api_data: {},
        odoo_datas: [],
        value1: 0,
        windowHeight: 500,
        windowWidth: 500,
        showDescription: false,
        fullMaterials: false,
        showToolbar: true,
        applyButton: true,

        onEdit: false,
        display_action: true,
        onEditGroupName: false,

        showSetting: false,
        showCollection: window.localStorage.getItem(PLUGIN_ID + '_showCollection') == 'true',
        exampleCollection: '0a949572-7049-49ae-8dac-c6b40748d1fc',
        searchCollectionItem: '',
        collectionItemType: 3,
        loadingCollection: false,

        dialogFormMakeGroup: false,
        dialogEditGroupVisible: false,
        newGroup: {
          label: "",
        },

        dialogAddDefaultVisible: false,
        dialogAttrLabelVisible: false,
        dialogOptionImageVisible: false,
        dialogbBehaviorVisible: false,
        dialogEditAttributeVisible: false,
        defaultSuggest: "",
        selectedAttibute: null,
        renderSuggestion: true,
        suggestions: [],
        default_types: {
          value: true,
        },
        dialogTooltipVisible: false,
        layoutTypes: [
          {
            value: "1column",
            label: "",
            numCol: 1,
          },
          {
            value: "2column",
            label: "",
            numCol: 2,
          },
        ],
        dialogEditLayoutVisible: false,
        selected_group: null,
        selected_layout: null,
        selected_attr: null,
        addImageVisible: false,
        addSectionVisible: false,
        labelposition: "right",
        predefineColors: [
          '#14ff73',
          '#06a647',
          '#263238',
          '#92989b',
          '#297fff',
          '#ff4114',
          '#fd8014',
        ]
      };
    },
    methods: {
      randomNum(){
        return Math.random();
      },
      onResize: function (x, y, width, height) {
        this.x = x
        this.y = y
        this.width = width
        this.height = height
      },
      onDrag: function (x, y) {
        this.x = x
        this.y = y
      },
      handleRemove(file, fileList) {
      },
      handlePreview(file) {
      },
      addUImageFilesChange(ile, fileList) {
        this.selected_layout.file_images = fileList;
      },
      handleExceed(files, fileList) {
        this.$message.warning(
          `The limit is 3, you selected ${
            files.length
          } files this time, add up to ${
            files.length + fileList.length
          } totally`
        );
      },
      beforeRemove(file, fileList) {
        return this.$confirm(`Cancel the transfert of ${file.name} ?`);
      },
      querySuggestions(queryString, cb) {
        if (this.suggestions) {
          cb(
            this.suggestions.map((value) => {
              return {
                value: value,
              };
            })
          );
        } else {
          cb([]);
        }
      },
      showAddSuggestValue(attribute) {
        attribute.suggestions
          ? attribute.suggestions
          : (attribute.suggestions = []);
        this.selectedAttibute = attribute;
        this.dialogAddDefaultVisible = true;
      },
      handleSelect(attribute) {
      },
      handleClose(attribute, tag) {
        attribute.suggestions.splice(attribute.suggestions.indexOf(tag), 1);
        this.changeAttrSuggestion(this.selectedAttibute);
        this.renderSuggestion = false;
        this.$nextTick((_) => {
          app.renderSuggestion = true;
        });
      },
      handleClose(attribute, tag) {
        if (!attribute.suggestions) {
          attribute.suggestions = [];
        }
        attribute.suggestions.splice(attribute.suggestions.indexOf(tag), 1);

        // save on sketchup
        this.changeAttrSuggestion(attribute);

        // rerender
        this.renderSuggestion = false;
        this.$nextTick((_) => {
          app.renderSuggestion = true;
        });
      },
      addAttrSuggest() {
        let defaultSuggest = this.defaultSuggest;
        if (defaultSuggest) {
          value = this.convertDisplayValue(
            this.selectedAttibute,
            defaultSuggest
          );
          this.selectedAttibute.suggestions.push(value);

          this.selectedAttibute.suggestions.sort((a, b) => {
            let value_a = this.sortDisplayValue(this.selectedAttibute, a);
            let value_b = this.sortDisplayValue(this.selectedAttibute, b);
            if (value_a < value_b) return -1;
            if (value_a > value_b) return 1;
            return 0;
          });

          this.changeAttrSuggestion(this.selectedAttibute);
        }
        // this.dialogAddDefaultVisible = false;
        this.defaultSuggest = "";
      },
      sortDisplayValue(attribute, display_value) {
        let units = su.ifEmpty(attribute.units, "STRING");
        if (units == "DEFAULT") {
          units = skp.units();
        }

        display_value = conv.format(display_value, units);
        return conv.toBase(display_value, units);
      },
      changeAttrSuggestion(attribute) {
        sketchup.changeAttrSuggestion(attribute);
      },
      defaultMaterial() {
        let names = Object.keys(this.data.materials);
        return this.data.materials[names[0]];
      },
      append(data) {
        const newChild = {
          id: id++,
          label: "testtest",
          children: [],
        };
        if (!data.children) {
          this.$set(data, "children", []);
        }
        data.children.push(newChild);
      },

      remove(node, data) {
        const parent = node.parent;
        const children = parent.data.children || parent.data;
        const index = children.findIndex((d) => d.id === data.id);
        children.splice(index, 1);
      },
      accept(value) {
        var data = {};
        data.plant = this.plant;
        data.plant_group = this.plant_group;
        sketchup.accept(data);
      },
      changeAttrValue(attribute, redraw, onChange) {
        console.log("changeAttrValue", attribute.name, attribute.value, 'redraw', redraw, 'onChange', onChange);

        let name = attribute.name;
        // console.log(name, attribute);

        if (attribute.access == "TEXTBOX") {
          this.changeTextboxValue(attribute);

          if (attribute.display_type == "SLIDER") {
            if (attribute.units == "PERCENT") {
              attribute.display_value *= 100;
            }
          }
        }

        // console.log(name, attribute)
        sketchup.change_attr_value(attribute);

        // set new attribute for list
        if (this.isCustomDisplayList(name)) {
        }

        if (!this.applyButton || redraw) {
          // Chờ đóng dropdown
          setTimeout(function () {
            app.apply(onChange);
          }, 150);
        }
      },

      onChangeAttrValue(attribute){
        return;
        this.changeAttrValue(attribute, true, true)
      },

      // User thay doi value của textbox
      changeTextboxValue(attribute) {
        var units = su.ifEmpty(attribute.units, "STRING");
        if (units == "DEFAULT") {
          units = skp.units();
        }

        var displayValue;
        var baseValue;
        var enteredValue = conv.parseTo(attribute.display_value, units, skp.decimalDelimiter());
        baseValue = conv.toBase(enteredValue, units);
        displayValue = conv.format(conv.fromBase(baseValue, units), units,
        cfg.DEFAULT_FORMAT_DECIMAL_PLACES, true, skp.decimalDelimiter());

        // console.log(baseValue, displayValue);

        // attribute.display_value = conv.format(attribute.display_value, units);
        // attribute.changed_value = conv.toBase(attribute.display_value, units);
        // attribute.value = attribute.changed_value;

        attribute.display_value = displayValue;
        attribute.changed_value = baseValue;
        attribute.value = attribute.changed_value;

        if (attribute.display_type == "SLIDER") {
          attribute.display_value = conv.toNumber(attribute.value);
        }

        return attribute.display_value;
      },
      formatDisplayValue(attribute, string){
        var units = su.ifEmpty(attribute.units, "STRING");
        if (units == "DEFAULT") {
          units = skp.units();
        }
        
        var baseValue;
        var enteredValue = conv.parseTo(string, units, skp.decimalDelimiter());
        baseValue = conv.toBase(enteredValue, units);
        displayValue = conv.format(conv.fromBase(baseValue, units), units,
        cfg.DEFAULT_FORMAT_DECIMAL_PLACES, true, skp.decimalDelimiter());
        return displayValue;
      },
      convertDisplayValue(attribute, value) {
        var units = su.ifEmpty(attribute.units, "STRING");
        if (units == "DEFAULT") {
          units = skp.units();
        }

        var displayValue;
        displayValue = conv.format(conv.fromBase(value, units), units,
        cfg.DEFAULT_FORMAT_DECIMAL_PLACES, true, skp.decimalDelimiter());

        return displayValue;
      },

      convertValueToDisplayValue(attribute, value) {
        var units = su.ifEmpty(attribute.units, "STRING");
        if (units == "DEFAULT") {
          units = skp.units();
        }
        // console.log(attribute, value)
        value = conv.format(value, units);
        return value;
      },

      convertDisplayValueToValue(attribute, display_value) {
        var units = su.ifEmpty(attribute.units, "STRING");
        if (units == "DEFAULT") {
          units = skp.units();
        }

        true_display_value = conv.format(display_value, units);
        value = conv.toBase(true_display_value, units);

        return value;
      },
      formatTooltip(val) {
        return val * 100 + "xxxx";
      },
      changeAttrDisplayType(attribute) {
        if (attribute.display_type == "SLIDER") {
          if (attribute.slidermin == undefined) {
            attribute.slidermin = 0;
            attribute.slidermax = 100;
            attribute.sliderstep = 5;
          }
        } else if (attribute.display_type == "RADIO") {
          if (attribute.radiostyle == undefined) {
            attribute.radiostyle = "DEFAULT";
          }

          this.setDefaultRadioImageData(attribute)
        } else if (attribute.display_type == "SWITCH"){
          if (attribute.active_value == undefined){
            if (isBoolean(attribute)){
              attribute.active_value = '0'
            }else {
              attribute.active_value = Object.values(attributes.options[0])
            }
          }
        }

        console.log("changeAttrDisplayType", attribute);
        sketchup.change_attr_displaytype(attribute, {
          onCompleted(){
            app.refreshAttribute(attribute);
          }
        });
      },
      
      listOptions(attribute) {
        return attribute.options;
      },

      isIdol() {
        return this.data && this.data.collection && this.data.collection.creator.id == 'ud50a1d69-0505-46f7-beb7-a06a75d94ca5'
      },

      isCustomAttribute(attribute) {
        customs = [
          'Group',
          'GRID',
          'Block',
          'Fieldset',
          'Divider',
          'Section',
          'Image',
        ]
        return customs.includes(attribute.access);
      },

      isMaterial(attribute) {
        if (attribute.name == "material") {
          return true;
        } else if (attribute.display_type == "MATERIAL") {
          return true;
        }
        // else if (attribute.name.substring(0,4).toLowerCase() == 'a06_') {
        //   return true;
        // }

        return false;
      },

      isControlDisplayList(attribute) {
        return false;
      },
      isCustomDisplayList(attribute) {
        return false;
      },

      listDisplay(options, control_value) {
        labels = Object.keys(options).filter((label) => {
          values = label.split("-")[1].split(",");
          return values.includes(control_value);
        });
        list = {};
        labels.forEach((label) => {
          list[label.split("-")[0]] = options[label];
        });
        return list;
      },
      noMatchMaterialValue(attribute) {
        // var iscustom = this.isCustomDisplayList(attribute.name);
        // var list = this.listOptions(attribute);

        // const values = Object.keys(list).map((k) => list[k]);


        // if (values.indexOf(attribute.value) > -1) {
        // } else {
        //   attribute.value = list[Object.keys(list)[0]];
        //   this.changeAttrValue(attribute);
        // }

        return "No match value";
      },

      changeSliderProps(attribute) {
        // console.log(attribute)

        if (attribute.slidermin >= attribute.slidermax) {
          alert("Min > Max!!!");
          attribute.slidermin = attribute.slidermax - 1;
        } else if (
          attribute.sliderstep >=
          attribute.slidermax - attribute.slidermin
        ) {
          alert("Step > Max - Min!!!");
          attribute.sliderstep = attribute.slidermax - attribute.slidermin;
        }

        this.changeAttrDisplayType(attribute);
      },

      dcAttribute(name) {
        try {
          // if(name == undefined){
          //   return this.data.attributeDictionaries.dynamic_attributes;
          // }

          return this.data.attributeDictionaries.dynamic_attributes[name];
        } catch (error) {
          return;
        }
      },

      pickModel(model, event) {
        // console.log(model, event)
        keys = {}
        keys.altKey = event.altKey;
        keys.ctrlKey = event.ctrlKey;
        keys.metaKey = event.metaKey;
        keys.shiftKey = event.metaKey;
        sketchup.pickModel(model, keys)
      },

      submit() {
        sketchup.apply(this.data);
      },

      editSetting() {
        this.showSetting = false;
        // console.log(this.dialog_settings)
        sketchup.saveSettings(this.dialog_settings)
      },

      toggleCollection() {
        this.showCollection = !this.showCollection;
        window.localStorage.setItem(PLUGIN_ID + '_showCollection', this.showCollection);

        if (this.showCollection){
          this.displayCollection()
        }

        sketchup.toggleCollection(
          this.showCollection, 
          [window.outerWidth, window.outerHeight],
          ''
        )
      },
      displayCollection(){
        var c;
        try {
          c = this.data.collection;
        } catch (error) {
          // c
        }

        // Check valid collection
        if (c && c.models.find(e => {return e.id == this.data.model_id})){
          // 
        } else if (this.data && this.data.model_id) {
          this.loadingCollection = true;
          c = findCollectionContainModelID(this.data.model_id)
          if(c){
            this.data.collection = c;
            this.loadingCollection = false;
          }else {
            findCollection(this.data.model_id)
          }
        }
      },
      reset() {
        this.$confirm(
          `This will permanently remove all struct. Continue?`,
          "Warning",
          {
            confirmButtonText: "OK",
            cancelButtonText: "Cancel",
            type: "warning",
          }
        )
        .then(() => {
          sketchup.reset();
        })
        .catch(() => {
          // this.$message({
          //   type: "info",
          //   message: "Reset canceled",
          // });
        });
      },
      thumbnailMaterial(material) {
        obj = this.data.materials.find((m) => {
          return m.value == material;
        });
        if (obj) {
          return obj.thumbnail;
        }
        return "";
      },
      apply(onChange) {
        sketchup.apply(this.data, onChange);
      },
      sketchup: function (value) {
        sketchup.say(value);
      },
      
      onSelect() {
      },
      selectedAttr() {
        if (
          !this.data ||
          !this.data.attributeDictionaries ||
          !this.data.attributeDictionaries.dynamic_attributes
        ) {
          return [];
        }

        keys = Object.keys(this.data.attributeDictionaries.dynamic_attributes);
        var selected = keys.filter((attr) => {
          obj = this.data.attributeDictionaries.dynamic_attributes[attr];
          return obj._edit_selected;
        });
        return selected;
      },
      addNewItemcode() {
        this.dialogAddMatCode = false;
        sketchup.addNewItemcode(this.data.material, this.new_mat_code);
        this.new_mat_code.name = "";
        this.new_mat_code.value = "";
      },

      addGroupAttribute() {
        // check valid name
        let name = this.newGroup.label;
        if (name == "") {
          return this.$message({
            type: "warning",
            message: "Invalide name!",
          });
        }

        if (
          this.data.attr_groups.find((gr) => {
            return gr.key == name;
          })
        ) {
          return this.$message({
            type: "warning",
            message: "Duplicate name!",
          });
        }

        let group = {
          access: 'Group',
          key: name,
          label: name,
          attributes: [],
          prefix: [],
          layout_type: 1,
          layout: [
            {
              span: 12,
              attributes: [],
            },
          ],
        };
        this.data.attr_groups.push(group);
        this.data.active_groups.push(name);

        sketchup.updateAttrGroup(group);

        this.dialogFormMakeGroup = false;
        this.newGroup.label = "";
      },
      startEditGroup(group) {
        this.onEditGroupName = true;
        this.selected_group = group;
        let label = group.label;
        let image = group.image;
        let key = group.key;
        this.newGroup.label = label;
        this.newGroup.image = image;
        this.newGroup.key = key;
        this.newGroup.on_edit = true;
        this.dialogEditGroupVisible = true;
      },
      onChangeGroupName(group) {
        // group.label
        // this.data.active_groups.push(group.label)
        this.data.active_groups.push(group.label);
      },
      changeXXX(group){
        sketchup.updateAttrGroup(group);
      },
      groupNameChanged(group) {
        // sketchup.updateAttrGroup(group);
        // return;

        if (this.validGroupName(group) == true) {
          if (group.key == group.label) return;
          console.log("changed name", group.key, group.label);

          group.key = group.label;

          // remove names in data.active_groups
          let valid_names = this.data.attr_groups.map((gr) => {
            return gr.label;
          });
          let active_groups = this.data.active_groups.filter((name) => {
            return valid_names.includes(name);
          });
          this.data.active_groups = active_groups;

          this.onEditGroupName = false;
        } else {
          group.label = group.key;
          this.$refs["inputGroupName_" + group.key][0].$refs.input.focus();
        }

        // sketchup.updateAttrGroup(group);
        // return;
      },

      validGroupName(group) {
        let name = group.label;
        if (name == "") {
          return this.$message({
            type: "warning",
            message: "Invalide name!",
          });
        }

        let exist_group = this.data.attr_groups.find((gr) => {
          return gr.key == name;
        });

        if (exist_group && exist_group.key != group.key) {
          return this.$message({
            type: "warning",
            message: "Duplicate name!",
          });
        }

        return true;
      },

      editGroupAttribute(group, e) {
        e.stopPropagation();

        // check valid name
        console.log('editGroupAttribute', group)

        if (this.validGroupName(group) == true){
          // Update Collopse actives
          let index = this.data.active_groups.indexOf(this.selected_group.label)
          this.$delete(this.data.active_groups, index)
          this.data.active_groups.push(group.label)
  
          // set
          this.selected_group.label = group.label
          this.selected_group.key = group.label
          this.selected_group.image = group.image
  
          sketchup.updateAttrGroup(this.selected_group);
          this.dialogEditGroupVisible = false;
  
          group.label = '';
          group.image = null;
        }

        // console.log(this.data.active_groups)
      },

      activeGroupsChanged() {
        sketchup.activeGroupsChanged(this.data.active_groups);
      },

      groupChanged(e, group) {
        console.log(e, group);
        // sketchup.updateAttrGroup(group);
      },

      editGroup(group, index) {
        console.log('editGroup')
      },
      removeGroupAttribute(group, index) {
        if (this.data.attr_groups.length == 1) {
          return this.$message({
            type: "info",
            message: "There must be at least one group!",
          });
        }

        this.$confirm(
          `This will permanently delete the "${group.label}" group. Continue?`,
          "Warning",
          {
            confirmButtonText: "OK",
            cancelButtonText: "Cancel",
            type: "warning",
          }
        )
          .then(() => {
            let attributes = group.attributes;

            // Move to
            moveToIndex = index == 0 ? index + 1 : index - 1;
            moveToGroup = this.data.attr_groups[moveToIndex];
            console.log(moveToGroup);

            attributes.forEach((attr) => {
              moveToGroup.attributes.push(attr);
            });

            this.$delete(this.data.attr_groups, index);

            sketchup.removeAttrGroup(group);

            this.$message({
              type: "success",
              message: "Delete completed",
            });
          })
          .catch(() => {
            this.$message({
              type: "info",
              message: "Delete canceled",
            });
          });
      },

      changeGroupLayout(group) {
        console.log(group);
        let numCol = group.layout_type.numCol;
        if (numCol == 1) {
          // Remove and merge to one column
          for (let i = 0; i < group.layout[1].attributes.length; i++) {
            const a = group.layout[1].attributes[i];
            group.layout[0].attributes.push(a);
          }

          // remove the second column
          this.$delete(group.layout, 1);
        } else if (numCol == 2) {
          group.layout.push({
            span: 12,
            attributes: [],
          });
        }
      },
      setGroupTitleHeight() {
        var height;
        if (this.onEdit) {
          height = "25px";
        } else {
          height = "22px";
        }
        let headers = document.getElementsByClassName(
          "el-collapse-item__header"
        );
        for (let i = 0; i < headers.length; i++) {
          const h = headers[i];
          h.style.height = height;
        }
      },
      paneresize(pane, container, size) {
        console.log(pane, container, size);
        multipane = document.getElementsByClassName("multipane")[0];
        ps = document.getElementsByClassName("layout-panel");
        totalWidth = multipane.offsetWidth;
        ps[0].style.width = parseInt(size, 10) + 20 + "px";
        ps[1].style.width = totalWidth - parseInt(size, 10) + "px";
        ps[1].style["flex-grow"] = 1;
        console.log([ps[0].style.width, ps[1].style.width]);
      },
      paneresizestop(pane, container, size) {
        console.log(pane, container, size);
        multipane = document.getElementsByClassName("multipane")[0];
        ps = document.getElementsByClassName("layout-panel");
        totalWidth = multipane.offsetWidth;
        ps[0].style.width = parseInt(ps[0].style.width, 10) + 20 + "px";
        console.log([ps[0].style.width, ps[1].style.width]);
      },
      panelLayoutWidth(group, index) {
        if (index == 0) {
          if (group.layout.length == 1) {
            return {
              width: "100%",
            };
          } else {
            // return { width: '50%', maxWidth: '90%' }
          }
        } else {
          // return { maxWidth: '90%' }
          // return { flexGrow: 1 };q
        }
      },

      setLayoutMinWidth(layout) {
      },

      editAttribute(attribute) {
        this.selected_attr = attribute;

        if (this.attrCanSetInputWidth(attribute) && !attribute.set_input_width){
          try {
            let w = Math.ceil((this.selected_attr.validInputSpace())/10) * 10 - 10;
            console.log(this.selected_attr.validInputSpace(), w)
            attribute.input_width = w;
          } catch (error) {
            attribute.input_width = 150;
          }
        }

        if(this.selected_attr.label_style == undefined){
          this.selected_attr.label_style = [];
        }

        if (this.isMaterial(this.selected_attr) && !this.selected_attr.option_use_image){
          this.selected_attr.option_use_image = true;
        }

        this.selected_attr.on_edit = true;
        this.dialogEditAttributeVisible = true
      },

      applyEditAttribute(attribute){
        attribute.on_edit = false ;
        attribute.onEdited('done')
        this.dialogEditAttributeVisible = false; 
        this.selected_attr = null;
        this.refreshAttribute(attribute);
      },

      attributeChangedProp(attribute){
        sketchup.attributeChangedProp(attribute)
      },

      editLayout(layout, ref) {
        layout.width = ref.$el.offsetWidth;
        layout.min_width = layout.min_width || layout.width;
        layout.max_width = layout.max_width || layout.width + 100;

        layout.file_images = [];

        this.selected_layout = layout;
        this.selected_layout.on_edit = true;
        this.dialogEditLayoutVisible = true;
      },

      applyEditLayout(layout){
        this.refreshAttribute(layout);
        this.dialogEditLayoutVisible = false;
        this.selected_layout.on_edit = false;
        this.selected_layout = null;
      },

      addLayoutBlock(layout, index) {
        let block = {
          render: true,
          access: "Block",
          formlabel: 'Block',
          hide_label: false,
          label_style: [],
          border: false,
          background_color: 'rgba(255, 255, 255, 0)',
          num_col: 1,
          name: '',
          key: parse_uuid(),
          attributes: [
            {
              render: true,
              access: 'Column',
              hide_label: false,
              label_style: [],
              name: '',
              key: parse_uuid(),
              span: 12,
              attributes: []
            }
          ],
        }

        this.setDefaultBehavior(block)
        layout.attributes.push(block);
      },
    
      addLayoutFieldset(layout, index) {
        let fieldset = {
          access: "Fieldset",
          formlabel: 'Fieldset',
          border: false,
          background_color: 'rgba(255, 255, 255, 0)',
          name: parse_uuid(),
          key: parse_uuid(),
          legend: null,
          legend_control: 'Disable',
          legends: [],
          attributes: [],
        }

        this.setDefaultBehavior(fieldset)
        layout.attributes.push(fieldset);
      },
      
      addLayoutDivide(layout, index) {
        layout.attributes.push({
          access: "Divider",
          formlabel: '',
          hide_label: false,
          label_style: [],
          direction: 'horizontal',
          label_position: 'left',
          key: parse_uuid()
        });
      },
      addLayoutSection(layout, index) {
        let section = {
          access: "Section",
          name: "Section",
          key: parse_uuid()
        }
        layout.attributes.push(section);
        this.selected_attr = section;
        this.addSectionVisible = true;
      },
      addLayoutImage(layout, image, index) {
        if (index == undefined) {
          index = layout.attributes.length;
        }

        img = {
          access: "Image",
          formlabel: 'Image',
          key: parse_uuid(),
          image: image,
          position: "flex-start",
          border: false,
          background_color: 'rgba(255, 255, 255, 0)',
          attributes: [
            // {
            //   key: parse_uuid(),
            //   x: 0,
            //   y: 0,
            //   w: 150,
            //   h: 'auto',
            //   attributes: []
            // }
          ],
          width: layout.width ? layout.width * 0.5 : null,
          height: null,
        };

        console.log('addLayoutImage', layout)
        layout.attributes.splice(index, 0, img);
      },
      insertImageURLToLayout(layout, url) {
        sketchup.insertImageURLToLayout(url, {
          onCompleted: function () {
            layout.add_image_url = '';
            data = app.rb_value;
            if (data) {
              app.addLayoutImage(app.selected_layout, data);
              app.rb_value = null;

              app.addImageVisible = false;
              app.dialogEditLayoutVisible = false;
            }
          },
        });
      },
      openpanelImageFile(item, size) {
        sketchup.openpanelImageFile(size, {
          onCompleted: function () {
            data = app.rb_value;
            if (data) {
              app.addLayoutImage(app.selected_layout, data);
              app.rb_value = null;

              app.addImageVisible = false;
              app.dialogEditLayoutVisible = false;
            }
          },
        });
      },

      insertImageFile(item, size) {
        sketchup.openpanelImageFile(size, {
          onCompleted: function () {
            data = app.rb_value;
            if (data) {
              
              item.image = data;
              app.rb_value = null;
              app.$forceUpdate();
            }
          },
        });
      },


      removeCustomAttribute(attribute, parent) {
        console.log('removeCustomAttribute', parent, attribute);
        if (!parent) {
          let path = attributeTreePath(attribute.path);
          parent = path[path.length-1]
        }

        // Move children
        children = attributeChildren(attribute);

        index = parent.attributes.indexOf(attribute)

        this.$delete(parent.attributes, index);

        if (children){
          for (let i = 0; i < children.length; i++) {
            const c = children[i];
            parent.attributes.push(c);
          }
        }

        // sketchup.updateAttrGroup(group);
      },

      attributeVisible(attribute) {
        try {
          visible = attribute.behavior.visible
        } catch (error) {
          return true;
        }
        
        if(!visible){
          return true;
        }

        attr_name = visible.attr_name;
        attr = this.dcAttribute(attr_name)

        if(attr){
          if(isSwitch(attr)){
            return Object.values(attr.options)[0] == attr.value;
          }

          if(isBoolean(attr)){
            return attr.value == 0 || attr.value == '0';
          }

          if(attr.access == 'LIST'){
            conditions = visible.conditions
            operator = conditions.operator
            values = conditions.values
            if (operator == '=='){
              return values.includes(attr.value);
            }else if (operator == '!='){
              return !values.includes(attr.value);
            }
          }
        }
        return attr ? attr.value : true;
      },

      attributeDisabled(attribute) {
        try {
          disabled = attribute.behavior.disabled
        } catch (error) {
          return false;
        }
         
        if(!disabled){
          return true;
        }

        attr_name = disabled.attr_name;
        attr = this.dcAttribute(attr_name)

        if(attr){
          if(isSwitch(attr)){
            return Object.values(attr.options)[0] == attr.value;
          }

          if(isBoolean(attr)){
            return attr.value == 0 || attr.value == '0';
          }

          if(attr.access == 'LIST'){
            conditions = disabled.conditions
            operator = conditions.operator
            values = conditions.values
            if (operator == '=='){
              return values.includes(attr.value);
            }else if (operator == '!='){
              return !values.includes(attr.value);
            }
          }
        }

        return attr ? attr.value : false;
      },

      setAttributeBehavior(attribute) {
        if(!attribute.behavior) {
          this.setDefaultBehavior(attribute)
        }
        this.selected_attr = attribute;
        this.dialogbBehaviorVisible = true;
      },

      setDefaultBehavior(attribute){
        attribute.behavior = {
          visible: {
            attr_name: null,
            conditions: {
              operator: '',
              values: [],
            }
          },
          disabled: {
            attr_name: null,
            conditions: {
              operator: '',
              values: [],
            }
          }
        }
      },
      moveTo() {
        // console.log(this.selectedAttr());
      },
      editTree() {
        sketchup.show_tree();
      },
      canMakeGroup() {
        return this.selectedAttr().length > 0;
      },
      openURL(link) {
        // console.log(link);
        sketchup.openURL(link);
      },
      materialsStyle(value) {
        // console.log(value);
        style = {
          "margin-right": "5px",
          position: "absolute",
          display: "inline-block",
          margin: "0 5px",
          width:
            "calc(100% - " +
            (this.numMaterials(value).length * 30 -
              (this.numMaterials(value).length - 1) * 3 +
              2) +
            "px)",
        };
        return style;
      },
      numMaterials(value) {
        return value.split("+");
      },

      hasDataMaterialThumbnail(mat) {
        return (
          this.data.at_materials &&
          this.data.at_materials[mat] &&
          this.data.at_materials[mat].thumbnails &&
          this.data.at_materials[mat].thumbnails.small
        );
      },

      changeGroupState(e) {
        // Refresh form label position when use auto position
        let lastGroup = e[e.length-1]
        if(lastGroup){
          this.onEdit = true
          this.$nextTick((_)=>{
            this.onEdit = false;
          })
        }
        // sketchup.activeGroupsChanged(this.data.active_groups);
      },

      // Disable Collapse when edit name...
      disableCollapse(e) {
        e.stopPropagation();
      },
      collapseChanged(value) {
        console.log('collapseChanged', value)
        if (this.onEditGroupName == true) {
          return;
        }

        this.data.active_groups = value;
      },
      getCollapseData() {
        return {
          on: {
            change: this.changeGroupState,
            input: this.collapseChanged,
          },
          attrs: {
            wrap: true,
          },
          props: {
            value: this.data.active_groups,
          },
        };
      },
      editAttributeLabel(attribute) {
        if (!this.onEdit) return;

        console.log(attribute, attribute.formlabel);
        this.selected_attr = attribute;
        this.dialogAttrLabelVisible = true;
      },

      attributeMouseover(attribute) {
        attribute.hover = true;
        // console.log(attribute, attribute.formlabel)
        this.mouseFocusChanged(attribute);
      },

      attributeMouseleave(attribute) {
        attribute.hover = false;
        this.mouseFocusChanged(attribute);
        // console.log(attribute, attribute.formlabel)
      },

      mouseFocusChanged(attribute) {
        // return;
        // console.log('mouseFocusChanged', attribute)
        if (attribute.name == 'lenx' || attribute.name == 'leny' || attribute.name == 'leny'){
          // sketchup.mouseFocusChanged(attribute);
        }
      },

      expandEditAttributeTooltip(attribute) {
        sketchup.editTooltip(attribute);
      },

      toggleMode() {
        // Custom Group label height
        this.setGroupTitleHeight();

        if(this.onEdit){
          if(this.dialog_settings.password && this.dialog_settings.password != '') {
            this.$prompt('Password', 'Enter password to edit', {
              confirmButtonText: 'OK',
              cancelButtonText: 'Cancel',
              inputErrorMessage: 'Incorrect password!',
              inputValidator: function (value) {
                return value == app.dialog_settings.password;
              }
            }).then(({ value }) => {
              sketchup.toggleMode(this.onEdit);
              // if (value == this.dialog_settings.password){
              //   this.$message({
              //     type: 'success',
              //     message: 'Your password is:' + value
              //   });
              // } else {
              //   this.onEdit = false;
              //   return;
              // }
            }).catch(() => {
              this.onEdit = false;
            });
          }
        } else {
          saveData('onSwitchEditMode')
          sketchup.toggleMode(this.onEdit);
        }
      },
      needLicense(){
        this.$message({
          type: 'warning',
          message: 'Required Curic Studio to edit!'
        })
      },
      displayActionButton() {
        return this.display_action;
      },
      setDefaultRadioImageData(attribute) {
        if (attribute.radiostyle == "Image") {
          if (!attribute.option_image_size) {
            attribute.option_image_size = "small";
            attribute.option_hide_text = false;
          }

          if (!attribute.image_options) {
            attribute.image_options = {};
            for (let i = 0; i < Object.keys(attribute.options).length; i++) {
              const value = Object.keys(attribute.options)[i];
              attribute.image_options[value] = {};
            }
          }
        }
        // console.log('setDefaultRadioImageData', attribute)
      },
      addOptionImage(attribute, option_value) {
        // console.log(attribute, option_value);
        sketchup.addOptionImage(attribute, option_value, {
          onCompleted() {
            data = app.rb_value;
            if (data) {
              if (!attribute.image_options) {
                attribute.image_options = {};
                for (let i = 0; i < Object.keys(attribute.options).length; i++) {
                  const label = Object.keys(attribute.options)[i];
                  const value = attribute.options[label]
                  attribute.image_options[value] = {
                    base64: '',
                    id: '',
                    path: ''
                  }
                }
              }
              attribute.image_options[option_value] = data;
              // console.log(data);
              // console.log(attribute, option_value);
              app.$forceUpdate();
              app.rb_value = null;
            }
          },
        });
      },
      attrHasSuggestion(attribute) {
        if(attribute.access != 'TEXTBOX') return false;

        if(attribute.display_type && attribute.display_type != 'DEFAULT'){
          return false;
        }

        return true;
      },

      attrCanSetInputWidth(attribute) {
        if(['DEFAULT', 'SLIDER', 'MATERIAL'].includes(attribute.display_type)){
          return true;
        }

        if(attribute.display_type == 'RADIO' && attribute.radiostyle == 'Image'){
          return true;
        }

        return false;
      },

      changeOptionUseImage(attribute) {
        if(attribute.option_use_image && !attribute.option_image_size){
          attribute.option_image_size = 'small';
        }

        if(attribute.display_type == 'RADIO' && attribute.radiostyle == 'Image'){
          if(attribute.option_use_image == false){
            attribute.radiostyle = 'DEFAULT'
          }
        }
      },
      editAttrOptionImage(attribute) {
        // show dialog
        this.selected_attr = attribute;
        this.dialogOptionImageVisible = true;
      },

      refreshAttribute(attribute){
        attribute.render = false;
        this.$nextTick((_) => {
          attribute.render = true;
          app.$forceUpdate()
        });
      },
      needReLayoutDialog(){
        try {
          let infoHeight = this.$refs["attributeInfo"] ? this.$refs["attributeInfo"].$el.offsetHeight : 0;
          let actionHeight = this.$refs["attributeAction"] ? this.$refs["attributeAction"].$el.offsetHeight : 0;
          let el = this.$refs["attributeContainer"]
          return window.innerHeight - infoHeight - actionHeight == el.offsetHeight
        } catch (error) {
          return false
        }
      },
      layoutDialog(){
        // console.log('refresh layout')
        try {
          let infoHeight = this.$refs["attributeInfo"] ? this.$refs["attributeInfo"].$el.offsetHeight : 0;
          let actionHeight = this.$refs["attributeAction"] ? this.$refs["attributeAction"].$el.offsetHeight : 0;
  
          let el = this.$refs["attributeContainer"]
          if (el){
            el.style.height = window.innerHeight - infoHeight - actionHeight - 5 + 'px'
            // console.log(window.innerHeight, infoHeight, actionHeight, el.offsetHeight)
          }

          // console.log( this.$refs["attributeInfo"], infoHeight)
          // console.log( this.$refs["attributeAction"], actionHeight)
          // console.log(window.innerHeight)

        } catch (error) {
          console.log(error)
        }
      }
    },
    computed: {
      materialsStyle2(value) {
        // console.log(value);
        style = {
          position: "absolute",
          display: "inline-block",
          margin: "0 8px",
          width: "calc(100% - 30px)",
        };
        return style;
      },
      collectionItemStyle() {
        if (this.collectionItemType == 1){

        } 
        else if (this.collectionItemType == 2){
          return {
            width: '73px',
            height: 74 * (9/16) + 20 + 'px'
          };
        }
        else if (this.collectionItemType == 3){
          return {
            width: '150px',
            height: 150 * (9/16) + 20 + 'px'
          };
        }
        else if (this.collectionItemType == 4){
          return {
            width: '310px',
            height: 310 * (9/16) + 20 + 'px'
          };
        }
      },
      attributesHeight() {
        // xs size
        fix = window.outerWidth < this.xs ? 0 : 30;
        fix += this.onEdit ? 250 : 50;

        if (this.applyButton) {
          return this.windowHeight + this.windowWidth - this.windowWidth - 310 + fix + "px";
        } else {
          return this.windowHeight + this.windowWidth - this.windowWidth - 280 + fix + "px";
        }
      },

      attributeItemStyle() {
        return {};
        if (this.onEdit) {
          return {
            display: "flex",
            border: "1px solid darkgray",
            "border-radius": "2px",
            margin: "2px 0",
            padding: "2px",
          };
        } else {
          return {
            // 'border': '1px solid darkgray',
            "margin-bottom": "1px",
          };
        }
      },
    },
    updated: function () {
      this.setGroupTitleHeight();
      this.$nextTick(function () {
        this.layoutDialog();
      })
    },
    mounted: function () {
      this.windowHeight = window.innerHeight;
      this.windowWidth = window.outerWidth;

      if(this.showCollection && window.outerWidth < 340*2){
        sketchup.toggleCollection(this.showCollection, [window.outerWidth, window.innerHeight])
      }
      
      sketchup.ready(window.outerWidth, window.innerHeight);

      this.$nextTick(() => {
        window.addEventListener("resize", () => {
          console.log('resizze')
          resetDialogSize()
          // sketchup.resizeDialog(window.outerWidth, window.innerHeight);
        });

        window.addEventListener("mouseup", (e) => {
          // clearSelection();
        });
      });

      setTimeout(() => {
        turnOffAlert();
      }, 1000);
    },
  });
}

app = newVue();

function resetDialogSize(number) {

  if (number) console.log('resetDialogSize', number);

  app.windowHeight = window.innerHeight;
  app.windowWidth = window.outerWidth;
  if (number) app.windowWidth += number;
}

function saveData(action){
  console.log("saveData", action)
  sketchup.saveData(app.data, action, {
    onCompleted(){
      // console.log('onCompleted.saveData')
    }}
  );
}

function createEditor(size) {}

function checkSize(size) {
  sketchup.fix_size(window.outerWidth, window.outerHeight, size);
}

function updateSU_info(info) {
  console.log(su)

  for (var [key, value] of Object.entries(info)) {
    su.info[key] = value;
  }
}

function updateData(data) {
  console.log('updateData')
  console.log(data)

  // conv is converter object from dynamic component
  // fix template of degrees
  conv.units[6].template = '{value}"';
  conv.units[11].template = "{value}°";

  if (data && data.attributeDictionaries.dynamic_attributes){
    // Merge attribute on tree with dynamic_attributes data
    for (let i = 0; i < data.attr_groups.length; i++) {
      const group = data.attr_groups[i];
      set_attribute_data(group, data.attributeDictionaries.dynamic_attributes)
    }

    var dynamic_attributes = flat_tree_attribute(data.attr_groups);

    // Re-link app.data.attributeDictionaries.dynamic_attributes
    for (const [key, value] of Object.entries(data.attributeDictionaries.dynamic_attributes)) {
      let a = dynamic_attributes.find(a=>{
        return a.key == key;
      })
      if(a) data.attributeDictionaries.dynamic_attributes[key] = a;
    }

    // Format value for display
    for (var key in data.attributeDictionaries.dynamic_attributes) {
      // Skip loop if the property is from prototype
      if (!data.attributeDictionaries.dynamic_attributes.hasOwnProperty(key))
        continue;

      var obj = data.attributeDictionaries.dynamic_attributes[key];

      // Format HTML
      // Label
      // if (obj.formlabel) obj.formlabel = su.unescapeHTML(obj.formlabel);
      if (obj.formlabel) obj.formlabel = unenscape_html(obj.formlabel);
      
      // Value
      // if (obj.value) obj.value = su.unescapeHTML(obj.value);
      if (obj.value) obj.value = unenscape_html(obj.value);

      // Options
      if (obj.access == 'LIST'){
        console.log(obj.options);
        for (var [key, value] of Object.entries(obj.options)) {
          // key = su.unescapeHTML(key);
          // value = su.unescapeHTML(value);
          var newkey = unenscape_html(key);
          var newvalue = unenscape_html(value);

          // console.log([newkey, key], newvalue, value)

          if (newkey != key) delete obj.options[key];

          obj.options[newkey] = newvalue;
        }
      }

      obj.display_value = getDisplayValue(obj);

      if (obj.display_type == "SLIDER") {
        obj.display_value = conv.toNumber(obj.value);
        if (obj.units == "PERCENT") {
          obj.display_value *= 100;
        }
      }
    }
  }

  app.data = data;
  if (!app.data) return;

  if (app.data.active_groups.length == 0) app.data.active_groups = ['Attributes'];

  app.dynamic_attributes = flat_tree_attribute(app.data.attr_groups)

  // // Re-link app.data.attributeDictionaries.dynamic_attributes
  // for (const [key, value] of Object.entries(app.data.attributeDictionaries.dynamic_attributes)) {
  //   let a = app.dynamic_attributes.find(a=>{
  //     return a.key == key;
  //   })
  //   if(a) app.data.attributeDictionaries.dynamic_attributes[key] = a;
  // }

  // // Format value for display
  // if (data && data.hasOwnProperty("attributeDictionaries")) {
  //   if (data.attributeDictionaries.hasOwnProperty("dynamic_attributes")) {
  //     for (var key in data.attributeDictionaries.dynamic_attributes) {
  //       // Skip loop if the property is from prototype
  //       if (!data.attributeDictionaries.dynamic_attributes.hasOwnProperty(key))
  //         continue;

  //       var obj = data.attributeDictionaries.dynamic_attributes[key];

  //       // Format HTML
  //       // Label
  //       // if (obj.formlabel) obj.formlabel = su.unescapeHTML(obj.formlabel);
  //       if (obj.formlabel) obj.formlabel = unenscape_html(obj.formlabel);
        
  //       // Value
  //       // if (obj.value) obj.value = su.unescapeHTML(obj.value);
  //       if (obj.value) obj.value = unenscape_html(obj.value);

  //       // Options
  //       if (obj.access == 'LIST'){
  //         for (var [key, value] of Object.entries(obj.options)) {
  //           // key = su.unescapeHTML(key);
  //           key = unenscape_html(key);
  //           // value = su.unescapeHTML(value);
  //           console.log('decodeURI', value, unenscape_html(value))
  //           value = unenscape_html(value);
  //           obj.options[key] = value;
  //         }
  //       }

  //       var units = obj.units;
  //       if (!units) continue;

  //       obj.display_value = getDisplayValue(obj);
  //       // console.log(obj.display_type , obj)

  //       if (obj.display_type == "SLIDER") {
  //         obj.display_value = conv.toNumber(obj.value);
  //         if (obj.units == "PERCENT") {
  //           obj.display_value *= 100;
  //         }

  //         // console.log('SLIDER', obj)
  //         // obj.slidermin = conv.toNumber(obj.slidermin)
  //         // obj.slidermax = conv.toNumber(obj.slidermax)
  //         // obj.sliderstep = conv.toNumber(obj.sliderstep)
  //         // obj.slidermin = 1
  //         // obj.slidermax = 3
  //         // obj.sliderstep = 1
  //       }
  //     }
  //   }
  // }

  if(app.showCollection){
    app.displayCollection()
  }
}

function unenscape_html(value) {
  value = su.unescapeHTML(value);
  value = value.replace('%23', '#');

  // try {
  //   value = decodeURI(value);
  //   return value;
  // } catch (error) {
  // }
  
  return unenscape_html2(value);
  // return value;
}

function unenscape_html2(value) {
  try {
    var r = /\\u([\d\w]{4})/gi;
    value = value.replace(r, function (match, grp) {
    return String.fromCharCode(parseInt(grp, 16)); } );
    return unescape(value);
  } catch (error) {
    return value;
  }
}

function set_attribute_data(attribute, dynamic_attributes) {
  // let dc_attr = app.dcAttribute(attribute.name);
  let dc_attr = dynamic_attributes[attribute.name]

  if (dc_attr){
    for (const [key, value] of Object.entries(dc_attr)) {
      attribute[key] = value;
    }
  }

  if(attribute.attributes){
    for (let i = 0; i < attribute.attributes.length; i++) {
      const a = attribute.attributes[i];
      set_attribute_data(a, dynamic_attributes)
    }
  }
}

function flat_tree_attribute(array, attributes) {
  if (!attributes) attributes = [];
  for (let i = 0; i < array.length; i++) {
    const a = array[i];

    if (!app.isCustomAttribute(a)) attributes.push(a);

    if(a.attributes) flat_tree_attribute(a.attributes, attributes)
    if(a.legends) flat_tree_attribute(a.legends, attributes)
  }

  return attributes
}

function updateTooltip(attribute) {
  let attr = app.dcAttribute(attribute.name);

  attr.tooltip = attribute.tooltip;
  ref = attribute.name + "Tooltip";
  app.refreshAttribute(attribute);
  app.$forceUpdate();
}

function getDisplayValue(attr) {
  value = su.sanitizeHTML(attr.value);
  value = su.escapeHTML(value);

  if (attr.access != "LIST") {
    var units = su.ifEmpty(attr.units, "STRING");
    if (units == "DEFAULT") {
      units = skp.units();
    }
    value = conv.fromBase(attr.value, units);
    value = conv.format(
      value + "",
      units,
      cfg.DEFAULT_FORMAT_DECIMAL_PLACES,
      true,
      skp.decimalDelimiter()
    );
  }

  return value;
}

var loadDC = function (index) {
  if (index == 6) {
    sketchup.refresh_dialog();
  }
};
// Load js file
// https://stackoverflow.com/questions/950087/how-do-i-include-a-javascript-file-in-another-javascript-file
function dynamicallyLoadScript(urls) {
  // var script = document.createElement("script");  // create a script DOM node
  // script.src = url;  // set its src to the provided URL

  // document.head.appendChild(script);  // add it to the end of the head section of the page (could change 'head' to 'body' to add it to the end of the body section instead)

  for (let i = 0; i < urls.length; i++) {
    const url = urls[i];
    // Adding the script tag to the head as suggested before
    var head = document.head;
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.src = url;

    // Then bind the event to the callback function.
    // There are several events for cross browser compatibility.
    // script.onreadystatechange = loadDC(i);
    script.onload = loadDC(i);

    // Fire the loading
    head.appendChild(script);
  }

  setTimeout(() => {
    turnOffAlert();
  }, 1000);
}

function test_api_data(params) {
  app.test_api_data = params;
}

// Turn off alert
function turnOffAlert() {
  console.log("turnOffAlert");
  // Turn off alert
  window.onerror = function (msg, url, line) {
    var msg =
      su.translateString("ERROR: ") +
      msg +
      " @ " +
      url.slice(url.lastIndexOf("/")) +
      "[" +
      line +
      "]";

    console.log(msg);
    // alert(msg);
  };
}

// Remove all selected attributes
// selected attribute has selected prop
function clearSelectedAttribute() {
  if (!app.dynamic_attributes){
    return
  }

  for (let i = 0; i < app.dynamic_attributes.length; i++) {
    const a = app.dynamic_attributes[i];
    a.selected = false;
  }
}

function clearSelection() {
  if (window.getSelection) {
    window.getSelection().removeAllRanges();
  } else if (document.selection) {
    document.selection.empty();
  }
}

function isBoolean(attribute) {
  if(!attribute.options){
    return false;
  }

  if (!isSwitch(attribute)) {
    return false;
  }
  if (
    Object.values(attribute.options).includes("0") &&
    Object.values(attribute.options).includes("1")
  ) {
    return true;
  }
  if (
    Object.values(attribute.options).includes(0) &&
    Object.values(attribute.options).includes(1)
  ) {
    return true;
  }

  if (attribute.options.hasOwnProperty("No") && attribute.options.hasOwnProperty("Yes")) {
    return true;
  }

  return false;
}

// Active value of switch
function activeValue(attribute) {
  var t;
  
  if(attribute.active_value) {
    t = Object.keys(attribute.options).find(l=>{
      return attribute.options[l] == attribute.active_value;
    })
    if(!t) {
      attribute.active_value = Object.values(attribute.options)[0];
    }
  }
  if(!t) t = Object.keys(attribute.options)[0];

  return attribute.options[t];
}

function isSwitch(attribute) {
  if(!attribute.options){
    return false;
  }

  return Object.keys(attribute.options).length == 2;
}

function isBooleanChecked(attribute){
  if(!isSwitch(attribute)){
    return false
  }
  if(!isBoolean(attribute)){
    return false
  }
  
  if (attribute.value == '0'){
    return true
  }
  
  // if (attribute.value == attribute.options[Object.keys(attribute.options)[0]]){
  //   return true
  // }

  return false;
}

function parse_uuid() {
  return 'xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
    var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
    return v.toString(16);
  });
}

// Object path từ key_path
// key_path là path của 1 object/attribtue thuộc tree UI
// key_path của 1 object được tạo/update trong mounted của vue component
function attributeTreePath(path) {
  const object_path = [];
  const array = path.split('/');

  // Mỗi level = type::key
  keys = array.map(str => { return str.split('::')[1] })

  object = app.data.attr_groups;
  for (let index = 0; index < keys.length; index++) {
    const key = keys[index];
    if(!key) {continue;}

    object = objectByKey(object, key)
    object_path.push(object);
  }

  return object_path;
}

function objectByKey(object, key) {
  var attributes;
  if (Array.isArray(object)){
    attributes = object;
  } else if (object.attributes) {
    attributes = object.attributes;
  }

  attr = attributes.find(a => { return a.key == key; })
  return attr;
}

function attributeChildren(attribute) {
  if (!attribute.attributes) return ;
  debug = attribute
  var children = [];
  if (attribute.access == 'Block'){
    attribute.attributes.forEach(col => {
      col.attributes.forEach(a => { children.push(a)} )
    })
  }else if (attribute.access == 'Fieldset') {
    children = children.concat(attribute.legends);
    children = children.concat(attribute.attributes);
  }else if (attribute.access == 'Image') {
    attribute.attributes.forEach(block_input => {
      block_input.attributes.forEach(a => { children.push(a)} )
    })
  } else {
    children = children.concat(attribute.attributes)
  }

  return children;
}

var debug;

window.addEventListener('beforeunload', function (e) {
  if (app.onEdit) {
    // save data
    saveData('beforeunload');
  }
});

function findCollection(model_id) {
  const request = new Request("https://3dwarehouse.sketchup.com/warehouse/v1.0/entities/" + model_id);
  fetch(request)
  .then(response => response.json())
  .then(data => {
    // console.log(data)
    find_collection(data)
    return data
  })
  .catch(console.error);  

}

function find_collection(model, offset) {
  var params = {
    fq: "attribute:3DW:isLiveComponent:boolean!='true';containsEntityId==" + model.id,
    show: 'public',
    showBinaryMetadata: true,
    recordEvent: false,
    count: 20,
    contentType: '3dw',
    offset: offset == undefined ? 0 : offset,
  };

  var url = new URL("https://3dwarehouse.sketchup.com/warehouse/v1.0/collections");
  Object.keys(params).forEach(key => url.searchParams.append(key, params[key]));

  fetch(url)
  .then(response => response.json())
  .then(data => {

    // console.log(data, model)

    let collection = data.entries.find(c => {
      return c.creator.id == model.creator.id;
    })
    // console.log(collection)

    if (collection) {
      if (!data) return;

      app.data.collection = collection;
      cookie = getStoreCollection(app.data.collection.id)
      if (cookie){
        app.data.collection.models = cookie.models
        app.loadingCollection = false
      } else {
        getCollectionModels(collection.id)
      }
    } else if ( data.endRow < data.total ){
      offset = data.endRow;
      find_collection(model, offset);
    } else {
      app.data.collection = null;
      app.loadingCollection = false
    }
  })
  .catch(console.error);
}

function getCollectionModels(collection_id, models, offset) {
  if (models == undefined) models = [];
  var params = {
    fq: `parentIds==${collection_id};(subtype=exists=false,subtype=='')`,
    show: 'public',
    showBinaryMetadata: true,
    showAttributes: true,
    sortBy: 'createTime DESC',
    recordEvent: false,
    count: 10,
    contentType: '3dw',
    offset: offset == undefined ? 0 : offset,
  };

  var url = new URL("https://3dwarehouse.sketchup.com/warehouse/v1.0/entities");
  Object.keys(params).forEach(key => url.searchParams.append(key, params[key]));

  fetch(url)
  .then(response => response.json())
  .then(data => {
    models = models.concat(data.entries)

    // console.log(data)

    if ( data.endRow < data.total ){
      offset = data.endRow;
      getCollectionModels(collection_id, models, offset);
    } else {
      app.data.collection.models = models;
      app.loadingCollection = false;
      storeCollection(app.data.collection.id, JSON.stringify(app.data.collection), 5)
    }
  })
  .catch(console.error);
}

function findCollectionContainModelID(model_id) {
  collection_names = Object.keys(window.localStorage).filter(name => {
    return name.indexOf('collection_') > -1;
  })

  collections = collection_names.map(name => {
    let value = window.localStorage.getItem(name);
    if(value){
      return JSON.parse(value);
    }
  })

  return collections.find(c => {
    return c.models.find(e => { return e.id == model_id })
  })
}

function storeCollection(id, cvalue, exdays) {
  var d = new Date();
  d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
  var expires = "expires="+d.toUTCString();

  var name = 'collection_' + id;
  window.localStorage.setItem(name, cvalue)
}

function getStoreCollection(id) {
  var name = 'collection_' + id;
  var value = window.localStorage.getItem(name);
  if(value){
    return JSON.parse(value);
  }
  return;
}

function clearStoreCollection() {
  collection_names = Object.keys(window.localStorage).filter(name => {
    return name.indexOf('collection_') > -1;
  })

  collection_names.forEach(name => { window.localStorage.removeItem(name); })
}

function renameAttribute(name, new_name, new_label) {
  console.log('renameAttribute', name, new_name, new_label)
  var a = app.dcAttribute(name);

  if (a){
    a.name = new_name;
    a.key = new_name;
    app.data.attributeDictionaries.dynamic_attributes
    app.data.attributeDictionaries.dynamic_attributes[new_name] = a
    delete app.data.attributeDictionaries.dynamic_attributes[name];

    // save tree and save attribute
    sketchup.renameAttribute()
    sketchup.saveTree()
  }
}