var tooltip = new Vue({
  el: '#app',
  data: function() {
    return {
      attribute: {
        tooltip: {
          width: 150,
          height: 200,
          code: ''
        }
      },
      onEditTooltip: false,
    }
  },
  watch: {
    attribute: function(val, oldVal){
      console.log('change attribute', val, val.tooltip)
  
      if(!val.tooltip){
        val.tooltip = {
          width: 150,
          height: 200,
          code: ''
        };
      }
  
      $('#tooltip').summernote('code', val.tooltip.code);
      $('.note-editable').css('width', val.tooltip.width)
      $('#tooltip').summernote('focus');
    }
  },
  methods: {
    show(){
      this.onEditTooltip = true;
      $('#tooltip').summernote({
        height: 250,
        placeholder: 'Tooltip...',
        disableGrammar: true,
        focus: true,
        toolbar: [
          // [groupName, [list of button]]
          ['style', ['style']],
          ['fontweigth', ['bold', 'italic', 'underline', 'clear']],
          ['fontsize', ['fontsize']],
          ['font', ['strikethrough', 'superscript', 'subscript']],
          ['color', ['color']],
          ['para', ['ul', 'ol', 'paragraph']],
          ['height', ['height']],
          ['insert', ['picture', 'link']],
          ['misc', ['fullscreen']]
          // ['misc', ['fullscreen', 'codeview']]
        ],
        lineHeights: ['0.2', '0.3', '0.4', '0.5', '0.6', '0.8', '1.0'],
      });
    },
    cancel() {
      sketchup.apply();
    },
    remove() {
      sketchup.remove(this.attribute);
    },
    save() {
      this.onEditTooltip = false
      var note = $('#tooltip').summernote('code');
      $('#tooltip').summernote('destroy');
    
      console.log(note)
    },
    apply() {
      let code = $('#tooltip').summernote('code');
      this.attribute.tooltip.code = code
      sketchup.apply(this.attribute);
    },
    changeWidth(){
      $('.note-editable').css('width', this.attribute.tooltip.width)
    }
  },
  computed:{
  },
  mounted: function() {
    sketchup.ready(window.outerWidth, window.outerHeight);
    this.show();
  },
})

function editAttribute(attribute) {
  console.log(attribute)
  tooltip.attribute = attribute;
}