// ELEMENT.locale(ELEMENT.lang.en)

var app = new Vue({
  el: '#app',
  data: function() {
    return {
      activeNames: ['dimstyle', 'scene'],
      search: '',
      activeCategory: '',
      finder: [],
      displaySize: 1.5,
      listItemHeight: 500,
      minThumbnail: 48,
      canReplace: false,
      sortByInModel: true,
      components: [],
      isCollapseNavMenu: false
    }
  },
  methods: {
    // navmenu
    handleClick(key, keyPath) {
      console.log(key, keyPath);
      paths = key.split('-')
      var category = this.finder.categories[paths[0]]
      for (let index = 1; index < paths.length; index++) {
        const element = paths[index];
        category = category.categories[element]
      }

      this.components = category.components;
    },
    handleOpen(key, keyPath) {
      console.log(key, keyPath);
    },
    handleClose(key, keyPath) {
      console.log(key, keyPath);
    },
    accept(value){
      var data = {}
      data.plant = this.plant
      data.plant_group = this.plant_group
      sketchup.accept(data);
    },
    setLibrary(){
      sketchup.set_finder_directory();
    },
    newColection(){
      sketchup.new_colection();
    },
    removeColection(){
      sketchup.remove_colection();
    },
    selectComponent(e, comp){
      if (e.shiftKey){
        sketchup.select_all_instances(comp);
      }else{
        sketchup.place_component(comp);
      }
    },
    placeComponent(e, comp){
      console.log(e)
      console.log('placeComponent', comp)
      sketchup.place_component(comp);
    },
    // When change displaySize, save param
    changeDisplaySize(){
      sketchup.change_display_size(this.displaySize);
    },

    // Filter component
    searchComponent(){
      return this.finder.find(item=>{return item.name == app.activeCategory}).components.filter(item => {
        return item.name.toLowerCase().includes(this.search.toLowerCase())
      })
    },

    // Change Active category
    changeActiveCategory(){
      console.log('changeActiveCategory')
    },

    replaceComponent(e, comp){
      sketchup.replace_component(comp);
    },
    redraw(){
      sketchup.redraw();
    },
    sketchup: function(value){
      sketchup.say(value)
    },
    sortInModel: function() {
      function compareInModel(a, b) {
        if (a.in_model && !b.in_model)
          return -1;
        if (!a.in_model && b.in_model)
          return 1;
        return 0;
      }
      function compareName(a, b) {
        if (a.name < b.name)
          return -1;
        if (a.name > b.name)
          return 1;
        return 0;
      }

      this.finder.forEach(c => {
        if (this.sortByInModel){
          c.components.sort(compareInModel);
        }else{
          c.components.sort(compareName);
        }
      });
    }
  },
  watch: {
    activeCategory: function (newQuestion, oldQuestion) {
      console.log('changeActiveCategory')
      this.search = '';
    },
    sortByInModel: function (newSort, oldSort) {
      this.sortInModel();
    },
  },
  computed:{
    componentThumbnailWidth(){
      if (this.displaySize > 1){
        return this.displaySize * this.minThumbnail + 'px';
      }else{
        return '32px';
      }
    },
    categoriesHeight(){
      console.log(window.outerHeight - 50 + 'px')
      return this.listItemHeight - 90 + 'px';
    },
    // Tính độ cao của list để scroll
    listHeight(){
      console.log(window.outerHeight - 50 + 'px')
      return this.listItemHeight - 90 + 'px';
    },
    gridStyle(){
      if (this.displaySize > 1){
        return 'repeat(auto-fill, minmax(' + (this.displaySize * this.minThumbnail + 64) +'px' + ', 1fr))';
      }
      else{
        return 'auto';
      }
    },
    
  },
  mounted: function() {
    sketchup.ready();
    
    this.listItemHeight = window.innerHeight;
    this.$nextTick(() => {
      window.addEventListener('resize', () => {
        this.listItemHeight = window.innerHeight
        console.log(window.innerHeight)
      });
    })
  },
})

function updateFinder(finder) {
  app.finder = finder;
  if (app.finder && app.finder[0]){
    app.activeCategory = app.finder[0].name

    // sort
    app.sortInModel();
  }
}